<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="cy__crypto__core__prng__v1_8c" kind="file" language="C++">
    <compoundname>cy_crypto_core_prng_v1.c</compoundname>
    <includes local="yes" refid="cy__crypto__core__prng__v1_8h">cy_crypto_core_prng_v1.h</includes>
    <includes local="yes" refid="cy__crypto__core__hw__v1_8h">cy_crypto_core_hw_v1.h</includes>
    <includes local="yes" refid="cy__syslib_8h">cy_syslib.h</includes>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="cy__crypto__core__prng__v1_8c_1a36940ebceb29078ffda263482263442a" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__crypto__enums_1ga3a65158da3dc5cb6aa016ae599542aad">cy_en_crypto_status_t</ref></type>
        <definition>cy_en_crypto_status_t Cy_Crypto_Core_V1_Prng_Init</definition>
        <argsstring>(CRYPTO_Type *base, uint32_t lfsr32InitState, uint32_t lfsr31InitState, uint32_t lfsr29InitState)</argsstring>
        <name>Cy_Crypto_Core_V1_Prng_Init</name>
        <param>
          <type>CRYPTO_Type *</type>
          <declname>base</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>lfsr32InitState</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>lfsr31InitState</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>lfsr29InitState</declname>
        </param>
        <briefdescription>
<para>Initializes the PRND parameters. </para>        </briefdescription>
        <detaileddescription>
<para>Invoking this function causes a restart of the pseudo-random sequence.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>base</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the CRYPTO instance.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>lfsr32InitState</parametername>
</parameternamelist>
<parameterdescription>
<para>A non-zero seed value for the first LFSR.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>lfsr31InitState</parametername>
</parameternamelist>
<parameterdescription>
<para>A non-zero seed value for the second LFSR.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>lfsr29InitState</parametername>
</parameternamelist>
<parameterdescription>
<para>A non-zero seed value for the third LFSR.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para><ref kindref="member" refid="group__group__crypto__enums_1ga3a65158da3dc5cb6aa016ae599542aad">cy_en_crypto_status_t</ref> </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="75" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_prng_v1.c" bodystart="63" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_prng_v1.c" line="63" />
      </memberdef>
      <memberdef const="no" explicit="no" id="cy__crypto__core__prng__v1_8c_1a60040f80ef1b6c1107ff6345fe08ffbd" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__crypto__enums_1ga3a65158da3dc5cb6aa016ae599542aad">cy_en_crypto_status_t</ref></type>
        <definition>cy_en_crypto_status_t Cy_Crypto_Core_V1_Prng</definition>
        <argsstring>(CRYPTO_Type *base, uint32_t max, uint32_t *randomNum)</argsstring>
        <name>Cy_Crypto_Core_V1_Prng</name>
        <param>
          <type>CRYPTO_Type *</type>
          <declname>base</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>max</declname>
        </param>
        <param>
          <type>uint32_t *</type>
          <declname>randomNum</declname>
        </param>
        <briefdescription>
<para>Generates a Pseudo Random Number. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>base</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the CRYPTO instance.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>max</parametername>
</parameternamelist>
<parameterdescription>
<para>The maximum value of a random number.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>randomNum</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to a variable to store the generated pseudo random number.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para><ref kindref="member" refid="group__group__crypto__enums_1ga3a65158da3dc5cb6aa016ae599542aad">cy_en_crypto_status_t</ref> </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="114" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_prng_v1.c" bodystart="96" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_prng_v1.c" line="96" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>This file provides the source code to the API for the PRNG in the Crypto block driver. </para>    </briefdescription>
    <detaileddescription>
<para><simplesect kind="version"><para>2.30.3</para></simplesect>
Copyright 2016-2020 Cypress Semiconductor Corporation SPDX-License-Identifier: Apache-2.0</para><para>Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at</para><para><ulink url="http://www.apache.org/licenses/LICENSE-2.0">http://www.apache.org/licenses/LICENSE-2.0</ulink></para><para>Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License. </para>    </detaileddescription>
    <programlisting>
<codeline lineno="1"><highlight class="comment">/***************************************************************************/</highlight></codeline>
<codeline lineno="27"><highlight class="preprocessor">#include<sp />"cy_crypto_core_prng_v1.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="28"><highlight class="normal" /></codeline>
<codeline lineno="29"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(CY_IP_MXCRYPTO)</highlight><highlight class="normal" /></codeline>
<codeline lineno="30"><highlight class="normal" /></codeline>
<codeline lineno="31"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="32"><highlight class="normal" /><highlight class="keyword">extern</highlight><highlight class="normal"><sp /></highlight><highlight class="stringliteral">"C"</highlight><highlight class="normal"><sp />{</highlight></codeline>
<codeline lineno="33"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="34"><highlight class="normal" /></codeline>
<codeline lineno="35"><highlight class="normal" /><highlight class="preprocessor">#if<sp />(CPUSS_CRYPTO_PR<sp />==<sp />1)</highlight><highlight class="normal" /></codeline>
<codeline lineno="36"><highlight class="normal" /></codeline>
<codeline lineno="37"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_crypto_core_hw_v1.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="38"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_syslib.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="39"><highlight class="normal" /></codeline>
<codeline lineno="40"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="41"><highlight class="comment">*<sp />Function<sp />Name:<sp />Cy_Crypto_Core_V1_Prng_Init</highlight></codeline>
<codeline lineno="42"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="63"><highlight class="normal"><ref kindref="member" refid="group__group__crypto__enums_1ga3a65158da3dc5cb6aa016ae599542aad">cy_en_crypto_status_t</ref><sp />Cy_Crypto_Core_V1_Prng_Init(CRYPTO_Type<sp />*base,</highlight></codeline>
<codeline lineno="64"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />lfsr32InitState,</highlight></codeline>
<codeline lineno="65"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />lfsr31InitState,</highlight></codeline>
<codeline lineno="66"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />lfsr29InitState)</highlight></codeline>
<codeline lineno="67"><highlight class="normal">{</highlight></codeline>
<codeline lineno="68"><highlight class="normal"><sp /><sp /><sp /><sp />REG_CRYPTO_PR_LFSR_CTL0(base)<sp />=<sp />(uint32_t)(_VAL2FLD(CRYPTO_PR_LFSR_CTL0_LFSR32,<sp />lfsr32InitState));</highlight></codeline>
<codeline lineno="69"><highlight class="normal" /></codeline>
<codeline lineno="70"><highlight class="normal"><sp /><sp /><sp /><sp />REG_CRYPTO_PR_LFSR_CTL1(base)<sp />=<sp />(uint32_t)(_VAL2FLD(CRYPTO_PR_LFSR_CTL1_LFSR31,<sp />lfsr31InitState));</highlight></codeline>
<codeline lineno="71"><highlight class="normal" /></codeline>
<codeline lineno="72"><highlight class="normal"><sp /><sp /><sp /><sp />REG_CRYPTO_PR_LFSR_CTL2(base)<sp />=<sp />(uint32_t)(_VAL2FLD(CRYPTO_PR_LFSR_CTL2_LFSR29,<sp />lfsr29InitState));</highlight></codeline>
<codeline lineno="73"><highlight class="normal" /></codeline>
<codeline lineno="74"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__crypto__enums_1gga3a65158da3dc5cb6aa016ae599542aada15d5a5e1314e16c159b7d3fd6f3501b8">CY_CRYPTO_SUCCESS</ref>);</highlight></codeline>
<codeline lineno="75"><highlight class="normal">}</highlight></codeline>
<codeline lineno="76"><highlight class="normal" /></codeline>
<codeline lineno="77"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="78"><highlight class="comment">*<sp />Function<sp />Name:<sp />Cy_Crypto_Core_V1_Prng</highlight></codeline>
<codeline lineno="79"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="96"><highlight class="normal"><ref kindref="member" refid="group__group__crypto__enums_1ga3a65158da3dc5cb6aa016ae599542aad">cy_en_crypto_status_t</ref><sp />Cy_Crypto_Core_V1_Prng(CRYPTO_Type<sp />*base,</highlight></codeline>
<codeline lineno="97"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />max,</highlight></codeline>
<codeline lineno="98"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />*randomNum)</highlight></codeline>
<codeline lineno="99"><highlight class="normal">{</highlight></codeline>
<codeline lineno="100"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_Crypto_SetReg1Instr(base,<sp />max);</highlight></codeline>
<codeline lineno="101"><highlight class="normal" /></codeline>
<codeline lineno="102"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_Crypto_Run1ParamInstr(base,</highlight></codeline>
<codeline lineno="103"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_V1_PRNG_OPC,</highlight></codeline>
<codeline lineno="104"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_RSRC0_SHIFT);</highlight></codeline>
<codeline lineno="105"><highlight class="normal" /></codeline>
<codeline lineno="106"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Wait<sp />until<sp />the<sp />PRNG<sp />instruction<sp />is<sp />complete<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="107"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">while</highlight><highlight class="normal">(0uL<sp />!=<sp />_FLD2VAL(CRYPTO_STATUS_PR_BUSY,<sp />REG_CRYPTO_STATUS(base)))</highlight></codeline>
<codeline lineno="108"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="109"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="110"><highlight class="normal" /></codeline>
<codeline lineno="111"><highlight class="normal"><sp /><sp /><sp /><sp />*randomNum<sp />=<sp />(uint32_t)_FLD2VAL(CRYPTO_PR_RESULT_DATA32,<sp />REG_CRYPTO_PR_RESULT(base));</highlight></codeline>
<codeline lineno="112"><highlight class="normal" /></codeline>
<codeline lineno="113"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__crypto__enums_1gga3a65158da3dc5cb6aa016ae599542aada15d5a5e1314e16c159b7d3fd6f3501b8">CY_CRYPTO_SUCCESS</ref>);</highlight></codeline>
<codeline lineno="114"><highlight class="normal">}</highlight></codeline>
<codeline lineno="115"><highlight class="normal" /></codeline>
<codeline lineno="116"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />#if<sp />(CPUSS_CRYPTO_PR<sp />==<sp />1)<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="117"><highlight class="normal" /></codeline>
<codeline lineno="118"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="119"><highlight class="normal">}</highlight></codeline>
<codeline lineno="120"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="121"><highlight class="normal" /></codeline>
<codeline lineno="122"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />CY_IP_MXCRYPTO<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="123"><highlight class="normal" /></codeline>
<codeline lineno="124"><highlight class="normal" /></codeline>
<codeline lineno="125"><highlight class="normal" /><highlight class="comment">/*<sp />[]<sp />END<sp />OF<sp />FILE<sp />*/</highlight><highlight class="normal" /></codeline>
    </programlisting>
    <location file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_prng_v1.c" />
  </compounddef>
</doxygen>